﻿@page "/meta"
@page "/meta/{idMetaEditar:int}"


@using BlazorCrud.Shared;
@using BlazorCrud.Client.Services;

@inject IMetaService metaService;
@inject NavigationManager navegacion;

<h3>@titulo</h3>

<EditForm Model="meta" OnValidSubmit="OnValidSubmit">
    <DataAnnotationsValidator></DataAnnotationsValidator>

    <div>
        <label class="form-label">Nombre</label>
        <InputText class="form-control" @bind-Value="meta.Nombre"></InputText>
        <ValidationMessage For="@(() => meta.Nombre)"></ValidationMessage>
    </div>
    <div class="mb-3">
        <label class="form-label">Fecha</label>
        <InputDate class="form-control" @bind-Value="meta.Fecha"></InputDate>
        <ValidationMessage For="@(() => meta.Fecha)"></ValidationMessage>
    </div>


    <button class="btn btn-primary" type="submit">
        @btnTexto
    </button>

    <a class="btn btn-warning" href="metas">Volver</a>
</EditForm>


@code {
    [Parameter]
    public int idMetaEditar { get; set; } = 0;


    string titulo = string.Empty;
    string btnTexto = string.Empty;

    MetaDTO meta = new MetaDTO();
    List<MetaDTO> listaMeta = new List<MetaDTO>();


    protected override async Task OnInitializedAsync()
    {
        if (idMetaEditar != 0)
        {
            meta = await metaService.Buscar(idMetaEditar);
            meta.Fecha = DateTime.Today;
            btnTexto = "Actualizar Meta";
            titulo = "Editar Meta";
        }
        else
        {
            meta.Fecha = DateTime.Today;
            btnTexto = "Guardar Meta";
            titulo = "Nueva Meta";
            meta.Activa = true;
        }

        listaMeta = await metaService.Lista();
    }

    private async Task OnValidSubmit()
    {
        int idDevuelto = 0;
        if (idMetaEditar == 0)
            idDevuelto = await metaService.Guardar(meta);
        else
            idDevuelto = await metaService.Editar(meta);


        if (idDevuelto != 0)
            navegacion.NavigateTo("/metas");

    }


}
